2 # Copyright (c) 2005 Junio C Hamano
4 # This program is free software: you can redistribute it and/or modify
5 # it under the terms of the GNU General Public License as published by
6 # the Free Software Foundation, either version 2 of the License, or
7 # (at your option) any later version.
9 # This program is distributed in the hope that it will be useful,
10 # but WITHOUT ANY WARRANTY; without even the implied warranty of
11 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
12 # GNU General Public License for more details.
14 # You should have received a copy of the GNU General Public License
15 # along with this program. If not, see http://www.gnu.org/licenses/ .
17 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
18 echo "Error: The notmuch test suite requires a bash version >= 4.0"
19 echo "due to use of associative arrays within the test suite."
20 echo "Please try again with a newer bash (or help us fix the"
21 echo "test suite to be more portable). Thanks."
25 # if --tee was passed, write the output not only to the terminal, but
26 # additionally to the file test-results/$BASENAME.out, too.
27 case "$GIT_TEST_TEE_STARTED, $* " in
29 # do not redirect again
31 *' --tee '*|*' --va'*)
33 BASE=test-results/$(basename "$0" .sh)
34 (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
35 echo $? > $BASE.exit) | tee $BASE.out
36 test "$(cat $BASE.exit)" = 0
41 # Keep the original TERM for say_color and test_emacs
44 # For repeatability, reset the environment to known value.
50 export LANG LC_ALL PAGER TERM TZ
51 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
52 TEST_EMACS=${TEST_EMACS:-${EMACS:-emacs}}
54 # Protect ourselves from common misconfiguration to export
55 # CDPATH into the environment
62 # A regexp to match 5 and 40 hexdigits
63 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
64 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
66 _x04='[0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
67 _x32="$_x04$_x04$_x04$_x04$_x04$_x04$_x04$_x04"
69 # Each test should start with something like this, after copyright notices:
71 # test_description='Description of this test...
72 # This test checks if command xyzzy does the right thing...
75 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
76 TERM=$ORIGINAL_TERM &&
79 tput bold >/dev/null 2>&1 &&
80 tput setaf 1 >/dev/null 2>&1 &&
81 tput sgr0 >/dev/null 2>&1
88 -d|--d|--de|--deb|--debu|--debug)
90 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
92 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
93 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
94 -h|--h|--he|--hel|--help)
96 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
98 -q|--q|--qu|--qui|--quie|--quiet)
101 with_dashes=t; shift ;;
107 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
108 valgrind=t; verbose=t; shift ;;
110 shift ;; # was handled already
112 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
115 echo "error: unknown test option '$1'" >&2; exit 1 ;;
119 if test -n "$debug"; then
121 printf " %-4s" "[$((test_count - 1))]"
129 if test -n "$color"; then
135 error) tput bold; tput setaf 1;; # bold red
136 skip) tput bold; tput setaf 2;; # bold green
137 pass) tput setaf 2;; # green
138 info) tput setaf 3;; # brown
139 *) test -n "$quiet" && return;;
150 test -z "$1" && test -n "$quiet" && return
159 say_color error "error: $*\n"
168 test "${test_description}" != "" ||
169 error "Test script did not set test_description."
171 if test "$help" = "t"
173 echo "Tests ${test_description}"
177 echo $(basename "$0"): "Testing ${test_description}"
189 rm -rf "$TEST_TMPDIR"
190 if test -n "$GIT_EXIT_OK"
194 echo >&5 "FATAL: Unexpected exit with code $code"
200 # Note: TEST_TMPDIR *NOT* exported!
201 TEST_TMPDIR=$(mktemp -d "${TMPDIR:-/tmp}/notmuch-test-$$.XXXXXX")
204 test_decode_color () {
205 sed -e 's/.\[1m/<WHITE>/g' \
206 -e 's/.\[31m/<RED>/g' \
207 -e 's/.\[32m/<GREEN>/g' \
208 -e 's/.\[33m/<YELLOW>/g' \
209 -e 's/.\[34m/<BLUE>/g' \
210 -e 's/.\[35m/<MAGENTA>/g' \
211 -e 's/.\[36m/<CYAN>/g' \
212 -e 's/.\[m/<RESET>/g'
224 sed -e 's/$/Q/' | tr Q '\015'
228 tr '\015' Q | sed -e 's/Q$//'
231 # Generate a new message in the mail directory, with a unique message
232 # ID and subject. The message is not added to the index.
234 # After this function returns, the filename of the generated message
235 # is available as $gen_msg_filename and the message ID is available as
238 # This function supports named parameters with the bash syntax for
239 # assigning a value to an associative array ([name]=value). The
240 # supported parameters are:
242 # [dir]=directory/of/choice
244 # Generate the message in directory 'directory/of/choice' within
245 # the mail store. The directory will be created if necessary.
249 # Store the message in file 'name'. The default is to store it
250 # in 'msg-<count>', where <count> is three-digit number of the
255 # Text to use as the body of the email message
257 # '[from]="Some User <user@example.com>"'
258 # '[to]="Some User <user@example.com>"'
259 # '[subject]="Subject of email message"'
260 # '[date]="RFC 822 Date"'
262 # Values for email headers. If not provided, default values will
263 # be generated instead.
265 # '[cc]="Some User <user@example.com>"'
266 # [reply-to]=some-address
267 # [in-reply-to]=<message-id>
268 # [references]=<message-id>
269 # [content-type]=content-type-specification
270 # '[header]=full header line, including keyword'
272 # Additional values for email headers. If these are not provided
273 # then the relevant headers will simply not appear in the
278 # Controls the message-id of the created message.
284 # This is our (bash-specific) magic for doing named parameters
285 local -A template="($@)"
286 local additional_headers
288 gen_msg_cnt=$((gen_msg_cnt + 1))
289 if [ -z "${template[filename]}" ]; then
290 gen_msg_name="msg-$(printf "%03d" $gen_msg_cnt)"
292 gen_msg_name=${template[filename]}
295 if [ -z "${template[id]}" ]; then
296 gen_msg_id="${gen_msg_name%:2,*}@notmuch-test-suite"
298 gen_msg_id="${template[id]}"
301 if [ -z "${template[dir]}" ]; then
302 gen_msg_filename="${MAIL_DIR}/$gen_msg_name"
304 gen_msg_filename="${MAIL_DIR}/${template[dir]}/$gen_msg_name"
305 mkdir -p "$(dirname "$gen_msg_filename")"
308 if [ -z "${template[body]}" ]; then
309 template[body]="This is just a test message (#${gen_msg_cnt})"
312 if [ -z "${template[from]}" ]; then
313 template[from]="Notmuch Test Suite <test_suite@notmuchmail.org>"
316 if [ -z "${template[to]}" ]; then
317 template[to]="Notmuch Test Suite <test_suite@notmuchmail.org>"
320 if [ -z "${template[subject]}" ]; then
321 template[subject]="Test message #${gen_msg_cnt}"
324 if [ -z "${template[date]}" ]; then
325 template[date]="Fri, 05 Jan 2001 15:43:57 +0000"
328 additional_headers=""
329 if [ ! -z "${template[header]}" ]; then
330 additional_headers="${template[header]}
331 ${additional_headers}"
334 if [ ! -z "${template[reply-to]}" ]; then
335 additional_headers="Reply-To: ${template[reply-to]}
336 ${additional_headers}"
339 if [ ! -z "${template[in-reply-to]}" ]; then
340 additional_headers="In-Reply-To: ${template[in-reply-to]}
341 ${additional_headers}"
344 if [ ! -z "${template[cc]}" ]; then
345 additional_headers="Cc: ${template[cc]}
346 ${additional_headers}"
349 if [ ! -z "${template[references]}" ]; then
350 additional_headers="References: ${template[references]}
351 ${additional_headers}"
354 if [ ! -z "${template[content-type]}" ]; then
355 additional_headers="Content-Type: ${template[content-type]}
356 ${additional_headers}"
359 if [ ! -z "${template[content-transfer-encoding]}" ]; then
360 additional_headers="Content-Transfer-Encoding: ${template[content-transfer-encoding]}
361 ${additional_headers}"
364 # Note that in the way we're setting it above and using it below,
365 # `additional_headers' will also serve as the header / body separator
366 # (empty line in between).
368 cat <<EOF >"$gen_msg_filename"
369 From: ${template[from]}
371 Message-Id: <${gen_msg_id}>
372 Subject: ${template[subject]}
373 Date: ${template[date]}
374 ${additional_headers}
379 # Generate a new message and add it to the database.
381 # All of the arguments and return values supported by generate_message
382 # are also supported here, so see that function for details.
385 generate_message "$@" &&
386 notmuch new > /dev/null
389 # Deliver a message with emacs and add it to the database
391 # Uses emacs to generate and deliver a message to the mail store.
392 # Accepts arbitrary extra emacs/elisp functions to modify the message
393 # before sending, which is useful to doing things like attaching files
394 # to the message and encrypting/signing.
395 emacs_deliver_message ()
400 # before we can send a message, we have to prepare the FCC maildir
401 mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
402 $TEST_DIRECTORY/smtp-dummy sent_message &
405 "(let ((message-send-mail-function 'message-smtpmail-send-it)
406 (smtpmail-smtp-server \"localhost\")
407 (smtpmail-smtp-service \"25025\"))
411 (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
412 (message-goto-subject)
413 (insert \"${subject}\")
417 (message-send-and-exit))"
418 # opportunistically quit smtp-dummy in case above fails.
419 { echo QUIT > /dev/tcp/localhost/25025; } 2>/dev/null
420 wait ${smtp_dummy_pid}
421 notmuch new >/dev/null
424 # Generate a corpus of email and add it to the database.
426 # This corpus is fixed, (it happens to be 50 messages from early in
427 # the history of the notmuch mailing list), which allows for reliably
428 # testing commands that need to operate on a not-totally-trivial
429 # number of messages.
433 if [ -d $TEST_DIRECTORY/corpus.mail ]; then
434 cp -a $TEST_DIRECTORY/corpus.mail ${MAIL_DIR}
436 cp -a $TEST_DIRECTORY/corpus ${MAIL_DIR}
437 notmuch new >/dev/null
438 cp -a ${MAIL_DIR} $TEST_DIRECTORY/corpus.mail
442 test_begin_subtest ()
444 if [ -n "$inside_subtest" ]; then
445 exec 1>&6 2>&7 # Restore stdout and stderr
446 error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
448 test_subtest_name="$1"
450 # Remember stdout and stderr file descriptors and redirect test
451 # output to the previously prepared file descriptors 3 and 4 (see
453 if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
454 exec 6>&1 7>&2 >&3 2>&4
458 # Pass test if two arguments match
460 # Note: Unlike all other test_expect_* functions, this function does
461 # not accept a test name. Instead, the caller should call
462 # test_begin_subtest before calling this function in order to set the
466 exec 1>&6 2>&7 # Restore stdout and stderr
468 test "$#" = 3 && { prereq=$1; shift; } || prereq=
470 error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
474 if ! test_skip "$test_subtest_name"
476 if [ "$output" = "$expected" ]; then
477 test_ok_ "$test_subtest_name"
479 testname=$this_test.$test_count
480 echo "$expected" > $testname.expected
481 echo "$output" > $testname.output
482 test_failure_ "$test_subtest_name" "$(diff -u $testname.expected $testname.output)"
487 # Like test_expect_equal, but takes two filenames.
488 test_expect_equal_file ()
490 exec 1>&6 2>&7 # Restore stdout and stderr
492 test "$#" = 3 && { prereq=$1; shift; } || prereq=
494 error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
498 if ! test_skip "$test_subtest_name"
500 if diff -q "$expected" "$output" >/dev/null ; then
501 test_ok_ "$test_subtest_name"
503 testname=$this_test.$test_count
504 cp "$output" $testname.output
505 cp "$expected" $testname.expected
506 test_failure_ "$test_subtest_name" "$(diff -u $testname.expected $testname.output)"
511 test_emacs_expect_t () {
512 test "$#" = 2 && { prereq=$1; shift; } || prereq=
514 error "bug in the test script: not 1 or 2 parameters to test_emacs_expect_t"
517 if ! test_skip "$test_subtest_name"
519 test_emacs "(notmuch-test-run $1)" >/dev/null
521 # Restore state after the test.
522 exec 1>&6 2>&7 # Restore stdout and stderr
525 # Report success/failure.
529 test_ok_ "$test_subtest_name"
531 test_failure_ "$test_subtest_name" "${result}"
534 # Restore state after the (non) test.
535 exec 1>&6 2>&7 # Restore stdout and stderr
542 notmuch new | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
545 notmuch_search_sanitize ()
547 sed -r -e 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
550 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
551 notmuch_show_sanitize ()
553 sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
555 notmuch_show_sanitize_all ()
558 -e 's| filename:.*| filename:XXXXX|' \
559 -e 's| id:[^ ]* | id:XXXXX |'
562 notmuch_json_show_sanitize ()
564 sed -e 's|, |,\n |g' | \
566 -e 's|"id": "[^"]*",|"id": "XXXXX",|' \
567 -e 's|"filename": "[^"]*",|"filename": "YYYYY",|'
570 # End of notmuch helper functions
572 # Use test_set_prereq to tell that a particular prerequisite is available.
573 # The prerequisite can later be checked for in two ways:
575 # - Explicitly using test_have_prereq.
577 # - Implicitly by specifying the prerequisite tag in the calls to
578 # test_expect_{success,failure,code}.
580 # The single parameter is the prerequisite tag (a simple word, in all
581 # capital letters by convention).
584 satisfied="$satisfied$1 "
588 test_have_prereq () {
597 # declare prerequisite for the given external binary
598 test_declare_external_prereq () {
600 test "$#" = 2 && name=$2 || name="$binary(1)"
602 hash $binary 2>/dev/null || eval "
603 test_missing_external_prereq_${binary}_=t
605 echo -n \"\$test_subtest_missing_external_prereqs_ \" | grep -qe \" $name \" ||
606 test_subtest_missing_external_prereqs_=\"\$test_subtest_missing_external_prereqs_ $name\"
611 # Explicitly require external prerequisite. Useful when binary is
612 # called indirectly (e.g. from emacs).
613 # Returns success if dependency is available, failure otherwise.
614 test_require_external_prereq () {
616 if [ "$(eval echo -n \$test_missing_external_prereq_${binary}_)" = t ]; then
617 # dependency is missing, call the replacement function to note it
624 # You are not expected to call test_ok_ and test_failure_ directly, use
625 # the text_expect_* functions instead.
628 if test "$test_subtest_known_broken_" = "t"; then
629 test_known_broken_ok_ "$@"
632 test_success=$(($test_success + 1))
633 say_color pass "%-6s" "PASS"
638 if test "$test_subtest_known_broken_" = "t"; then
639 test_known_broken_failure_ "$@"
642 test_failure=$(($test_failure + 1))
643 test_failure_message_ "FAIL" "$@"
644 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
648 test_failure_message_ () {
649 say_color error "%-6s" "$1"
652 echo "$@" | sed -e 's/^/ /'
653 if test "$verbose" != "t"; then cat test.output; fi
656 test_known_broken_ok_ () {
658 test_fixed=$(($test_fixed+1))
659 say_color pass "%-6s" "FIXED"
663 test_known_broken_failure_ () {
665 test_broken=$(($test_broken+1))
666 test_failure_message_ "BROKEN" "$@"
671 test "$debug" = "" || eval "$1"
676 if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
679 eval >&3 2>&4 "$test_cleanup"
684 test_count=$(($test_count+1))
686 for skp in $NOTMUCH_SKIP_TESTS
688 case $this_test.$test_count in
693 if test -z "$to_skip" && test -n "$prereq" &&
694 ! test_have_prereq "$prereq"
700 test_report_skip_ "$@"
703 test_check_missing_external_prereqs_ "$@"
708 test_check_missing_external_prereqs_ () {
709 if test -n "$test_subtest_missing_external_prereqs_"; then
710 say_color skip >&1 "missing prerequisites:"
711 echo "$test_subtest_missing_external_prereqs_" >&1
712 test_report_skip_ "$@"
718 test_report_skip_ () {
720 say_color skip >&3 "skipping test:"
722 say_color skip "%-6s" "SKIP"
726 test_subtest_known_broken () {
727 test_subtest_known_broken_=t
730 test_expect_success () {
731 test "$#" = 3 && { prereq=$1; shift; } || prereq=
733 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
739 # test_run_ may update missing external prerequisites
740 test_check_missing_external_prereqs_ "$@" ||
741 if [ "$run_ret" = 0 -a "$eval_ret" = 0 ]
750 test_expect_code () {
751 test "$#" = 4 && { prereq=$1; shift; } || prereq=
753 error "bug in the test script: not 3 or 4 parameters to test-expect-code"
759 # test_run_ may update missing external prerequisites,
760 test_check_missing_external_prereqs_ "$@" ||
761 if [ "$run_ret" = 0 -a "$eval_ret" = "$1" ]
770 # test_external runs external test scripts that provide continuous
771 # test output about their progress, and succeeds/fails on
772 # zero/non-zero exit code. It outputs the test output on stdout even
773 # in non-verbose mode, and announces the external script with "* run
774 # <n>: ..." before running it. When providing relative paths, keep in
775 # mind that all scripts run in "trash directory".
776 # Usage: test_external description command arguments...
777 # Example: test_external 'Perl API' perl ../path/to/test.pl
779 test "$#" = 4 && { prereq=$1; shift; } || prereq=
781 error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
785 if ! test_skip "$descr" "$@"
787 # Announce the script to reduce confusion about the
788 # test output that follows.
789 say_color "" " run $test_count: $descr ($*)"
790 # Run command; redirect its stderr to &4 as in
791 # test_run_, but keep its stdout on our stdout even in
798 test_failure_ "$descr" "$@"
803 # Like test_external, but in addition tests that the command generated
804 # no output on stderr.
805 test_external_without_stderr () {
806 # The temporary file has no (and must have no) security
808 tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
809 stderr="$tmp/git-external-stderr.$$.tmp"
810 test_external "$@" 4> "$stderr"
811 [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
812 descr="no stderr: $1"
814 if [ ! -s "$stderr" ]; then
818 if [ "$verbose" = t ]; then
819 output=`echo; echo Stderr is:; cat "$stderr"`
823 # rm first in case test_failure exits.
825 test_failure_ "$descr" "$@" "$output"
829 # This is not among top-level (test_expect_success)
830 # but is a prefix that can be used in the test script, like:
832 # test_expect_success 'complain and die' '
834 # do something else &&
835 # test_must_fail git checkout ../outerspace
838 # Writing this as "! git checkout ../outerspace" is wrong, because
839 # the failure could be due to a segv. We want a controlled failure.
843 test $? -gt 0 -a $? -le 129 -o $? -gt 192
846 # test_cmp is a helper function to compare actual and expected output.
847 # You can use it like:
849 # test_expect_success 'foo works' '
850 # echo expected >expected &&
852 # test_cmp expected actual
855 # This could be written as either "cmp" or "diff -u", but:
856 # - cmp's output is not nearly as easy to read as diff -u
857 # - not all diff versions understand "-u"
863 # This function can be used to schedule some commands to be run
864 # unconditionally at the end of the test to restore sanity:
866 # test_expect_success 'test core.capslock' '
867 # git config core.capslock true &&
868 # test_when_finished "git config --unset core.capslock" &&
872 # That would be roughly equivalent to
874 # test_expect_success 'test core.capslock' '
875 # git config core.capslock true &&
877 # git config --unset core.capslock
880 # except that the greeting and config --unset must both succeed for
883 test_when_finished () {
885 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
890 test_results_dir="$TEST_DIRECTORY/test-results"
891 mkdir -p "$test_results_dir"
892 test_results_path="$test_results_dir/${0%.sh}-$$"
894 echo "total $test_count" >> $test_results_path
895 echo "success $test_success" >> $test_results_path
896 echo "fixed $test_fixed" >> $test_results_path
897 echo "broken $test_broken" >> $test_results_path
898 echo "failed $test_failure" >> $test_results_path
899 echo "" >> $test_results_path
903 [ -n "$EMACS_SERVER" ] && test_emacs '(kill-emacs)'
905 if [ "$test_failure" = "0" ]; then
906 if [ "$test_broken" = "0" ]; then
915 emacs_generate_script () {
916 # Construct a little test script here for the benefit of the user,
917 # (who can easily run "run_emacs" to get the same emacs environment
918 # for investigating any failures).
919 cat <<EOF >"$TMP_DIRECTORY/run_emacs"
922 export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
924 # Here's what we are using here:
926 # --no-init-file Don't load users ~/.emacs
928 # --no-site-file Don't load the site-wide startup stuff
930 # --directory Ensure that the local elisp sources are found
932 # --load Force loading of notmuch.el and test-lib.el
934 exec ${TEST_EMACS} --no-init-file --no-site-file \
935 --directory "$TEST_DIRECTORY/../emacs" --load notmuch.el \
936 --directory "$TEST_DIRECTORY" --load test-lib.el \
939 chmod a+x "$TMP_DIRECTORY/run_emacs"
943 # test dependencies beforehand to avoid the waiting loop below
944 missing_dependencies=
945 test_require_external_prereq dtach || missing_dependencies=1
946 test_require_external_prereq emacs || missing_dependencies=1
947 test_require_external_prereq emacsclient || missing_dependencies=1
948 test -z "$missing_dependencies" || return
950 if [ -z "$EMACS_SERVER" ]; then
951 emacs_tests="$(basename $0).el"
952 if [ -f "$TEST_DIRECTORY/$emacs_tests" ]; then
953 load_emacs_tests="--eval '(load \"$emacs_tests\")'"
957 server_name="notmuch-test-suite-$$"
958 # start a detached session with an emacs server
959 # user's TERM is given to dtach which assumes a minimally
960 # VT100-compatible terminal -- and emacs inherits that
961 TERM=$ORIGINAL_TERM dtach -n "$TEST_TMPDIR/emacs-dtach-socket.$$" \
962 sh -c "stty rows 24 cols 80; exec '$TMP_DIRECTORY/run_emacs' \
965 --eval '(setq server-name \"$server_name\")' \
966 --eval '(server-start)' \
967 --eval '(orphan-watchdog $$)'" || return
968 EMACS_SERVER="$server_name"
969 # wait until the emacs server is up
970 until test_emacs '()' >/dev/null 2>/dev/null; do
975 emacsclient --socket-name="$EMACS_SERVER" --eval "(progn $@)"
979 export LD_LIBRARY_PATH=$TEST_DIRECTORY/../lib
980 export PYTHONPATH=$TEST_DIRECTORY/../bindings/python
982 # Some distros (e.g. Arch Linux) ship Python 2.* as /usr/bin/python2,
983 # most others as /usr/bin/python. So first try python2, and fallback to
984 # python if python2 doesn't exist.
986 [[ "$test_missing_external_prereq_python2_" = t ]] && cmd=python
988 (echo "import sys; _orig_stdout=sys.stdout; sys.stdout=open('OUTPUT', 'w')"; cat) \
992 # Creates a script that counts how much time it is executed and calls
993 # notmuch. $notmuch_counter_command is set to the path to the
994 # generated script. Use notmuch_counter_value() function to get the
995 # current counter value.
996 notmuch_counter_reset () {
997 notmuch_counter_command="$TMP_DIRECTORY/notmuch_counter"
998 if [ ! -x "$notmuch_counter_command" ]; then
999 notmuch_counter_state_path="$TMP_DIRECTORY/notmuch_counter.state"
1000 cat >"$notmuch_counter_command" <<EOF || return
1003 read count < "$notmuch_counter_state_path"
1004 echo \$((count + 1)) > "$notmuch_counter_state_path"
1008 chmod +x "$notmuch_counter_command" || return
1011 echo 0 > "$notmuch_counter_state_path"
1014 # Returns the current notmuch counter value.
1015 notmuch_counter_value () {
1016 if [ -r "$notmuch_counter_state_path" ]; then
1017 read count < "$notmuch_counter_state_path"
1024 test_reset_state_ () {
1025 test -z "$test_init_done_" && test_init_
1027 test_subtest_known_broken_=
1028 test_subtest_missing_external_prereqs_=
1031 # called once before the first subtest
1035 # skip all tests if there were external prerequisites missing during init
1036 test_check_missing_external_prereqs_ "all tests in $this_test" && test_done
1040 find_notmuch_path ()
1044 while [ -n "$dir" ]; do
1046 if [ -x "$bin" ]; then
1050 dir="$(dirname "$dir")"
1051 if [ "$dir" = "/" ]; then
1057 # Test the binaries we have just built. The tests are kept in
1058 # test/ subdirectory and are run in 'trash directory' subdirectory.
1059 TEST_DIRECTORY=$(pwd)
1060 if test -n "$valgrind"
1064 test "$1" = "$(readlink "$2")" || {
1072 while test -d "$2".lock
1074 say "Waiting for lock on $2."
1081 make_valgrind_symlink () {
1082 # handle only executables
1083 test -x "$1" || return
1085 base=$(basename "$1")
1086 symlink_target=$TEST_DIRECTORY/../$base
1087 # do not override scripts
1088 if test -x "$symlink_target" &&
1089 test ! -d "$symlink_target" &&
1090 test "#!" != "$(head -c 2 < "$symlink_target")"
1092 symlink_target=$TEST_DIRECTORY/valgrind.sh
1096 symlink_target=$TEST_DIRECTORY/unprocessed-script
1098 # create the link, or replace it if it is out of date
1099 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
1102 # override notmuch executable in TEST_DIRECTORY/..
1103 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
1104 mkdir -p "$GIT_VALGRIND"/bin
1105 make_valgrind_symlink $TEST_DIRECTORY/../notmuch
1110 ls "$path"/notmuch 2> /dev/null |
1113 make_valgrind_symlink "$file"
1117 PATH=$GIT_VALGRIND/bin:$PATH
1118 GIT_EXEC_PATH=$GIT_VALGRIND/bin
1121 notmuch_path=`find_notmuch_path "$TEST_DIRECTORY"`
1122 test -n "$notmuch_path" && PATH="$notmuch_path:$PATH"
1127 test="tmp.$(basename "$0" .sh)"
1128 test -n "$root" && test="$root/$test"
1130 /*) TMP_DIRECTORY="$test" ;;
1131 *) TMP_DIRECTORY="$TEST_DIRECTORY/$test" ;;
1133 test ! -z "$debug" || remove_tmp=$TMP_DIRECTORY
1136 echo >&5 "FATAL: Cannot prepare test area"
1140 # A temporary home directory is needed by at least:
1141 # - emacs/"Sending a message via (fake) SMTP"
1142 # - emacs/"Reply within emacs"
1143 # - crypto/emacs_deliver_message
1144 export HOME="${TMP_DIRECTORY}/home"
1147 MAIL_DIR="${TMP_DIRECTORY}/mail"
1148 export GNUPGHOME="${TMP_DIRECTORY}/gnupg"
1149 export NOTMUCH_CONFIG="${TMP_DIRECTORY}/notmuch-config"
1152 mkdir -p "${MAIL_DIR}"
1154 cat <<EOF >"${NOTMUCH_CONFIG}"
1159 name=Notmuch Test Suite
1160 primary_email=test_suite@notmuchmail.org
1161 other_email=test_suite_other@notmuchmail.org;test_suite@otherdomain.org
1164 emacs_generate_script
1167 # Use -P to resolve symlinks in our working directory so that the cwd
1168 # in subprocesses like git equals our $PWD (for pathname comparisons).
1169 cd -P "$test" || error "Cannot setup test environment"
1171 if test "$verbose" = "t"
1175 exec 4>test.output 3>&4
1179 for skp in $NOTMUCH_SKIP_TESTS
1182 for skp in $NOTMUCH_SKIP_TESTS
1184 case "$this_test" in
1191 say_color skip >&3 "skipping test $this_test altogether"
1192 say_color skip "skip all tests in $this_test"
1197 # Provide an implementation of the 'yes' utility
1212 # Fix some commands on Windows
1215 # Windows has its own (incompatible) sort and find
1225 # git sees Windows-style pwd
1229 # no POSIX permissions
1230 # backslashes in pathspec are converted to '/'
1231 # exec does not inherit the PID
1234 test_set_prereq POSIXPERM
1235 test_set_prereq BSLASHPSPEC
1236 test_set_prereq EXECKEEPSPID
1240 test -z "$NO_PERL" && test_set_prereq PERL
1241 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1243 # test whether the filesystem supports symbolic links
1244 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1247 # declare prerequisites for external binaries used in tests
1248 test_declare_external_prereq dtach
1249 test_declare_external_prereq emacs
1250 test_declare_external_prereq emacsclient
1251 test_declare_external_prereq gdb
1252 test_declare_external_prereq gpg
1253 test_declare_external_prereq python
1254 test_declare_external_prereq python2